#if defined _d7_esp_included
  #endinput
#endif
#define _d7_esp_included

#include <D7ESP_const>

#if AMXX_VERSION_NUM >= 175
	#pragma reqlib D7ESP
	#if !defined AMXMODX_NOAUTOLOAD
		#pragma loadlib D7ESP
	#endif
#else
	#pragma library D7ESP
#endif

/**
 * Turns a player into a human.
 *
 * @param iID			Player index to be cured.
 * @param iAttackerID	Player who triggered the cure(optional).
 * @param bForce		Force the player to turn into a human even if he already is.
 * @param bOnSpawn		Unset RespawnAsZombie flag and don't cure right now.
 *						In this case, iAttackerID & bForce params don't matter.
 *						This can also be used while the player is dead(no alive error).
 *
 * @return				0/False if:
 *							Already is and bForce wasn't used.
 *							Error(index invalid or not connected/alive).
 *						1/True on success.
 */
//native ntD7ESPInfoGet(const iID, const iID2)

/**
 * Turns a player into a zombie.
 *
 * @param iID			Player index to be infected.
 * @param iAttackerID	Player who triggered the infection(optional).
 * @param bForce		Force the player to turn into a zombie even if he already is.
 * @param bOnSpawn		Set RespawnAsZombie flag and don't infect right now.
 *						In this case, iAttackerID & bForce params don't matter.
 *						This can also be used while the player is dead(no alive error).
 *
 * @return				0/False if:
 *							Already is and bForce wasn't used.
 *							Error(index invalid or not connected/alive).
 *						1/True on success.
 */
native iNtD7ESPSet(const iBsIDs1,
const iBsIDsAdd = g_iParamDontChange,
const iBsIDsRemove = g_iParamDontChange,
const iBsIDsChange = g_iParamDontChange,
const iIDEntModel = g_iParamDontChange,
const iEntFrameStart = g_iParamDontChange,
const iEntFrameEnd = g_iParamDontChange,
const Float:fEntFrameRate = g_fParamDontChange,
const Float:fEntScale = g_fParamDontChange,
const iEntRenderMode = g_iParamDontChange,
const iEntRenderFx = g_iParamDontChange,
const Float:fEntRenderAmount = g_fParamDontChange,
const Float:fEntOriginUpdateRate = g_fParamDontChange,
const iVecEntRenderColor[3] = { g_iParamDontChange, 0, 0 },
const Float:fVecEntOriginModifier[3] = { g_fParamDontChange, 0.0, 0.0 })
